#include "game_manager.h"

char selected = 0, selected_old = 0;
// ============================ button sprite ===========================

char resume_button_str[10];
void start_button_update(sprite_t* s, int dt){
    // only update the button once per selection change
    if (selected_old != selected){
    if (selected == 0){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
        video_removestring(s->pos.x + (s->width)/2 - 29, s->pos.y+(s->height)/2-4, resume_button_str);
    } else if (selected_old == 0 && selected != selected_old){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_BLACK);
        video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
        video_string(s->pos.x + (s->width)/2 - 29, s->pos.y+(s->height)/2-4, resume_button_str);
    }
    }
}

void start_button_init(sprite_t*s, int dt){
    s->width = 100;
    s->height = 30;
    vector2d pos = {(right+left)/2-50,(top+bottom)/2-40};
    s->pos = pos;
    s->current_frame = 0;
    s->data = NULL;
    s->frames = 0;
    s->update_func = start_button_update;
    sprintf(resume_button_str, "Start Game");
    video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
    video_removestring(s->pos.x + (s->width)/2 - 29, s->pos.y+(s->height)/2-4, resume_button_str);
}

sprite_t start_button = {0,0,0,0,0,0,start_button_init,0,0};

char settings_button_str[10];
void settings_button_update(sprite_t* s, int dt){
    if (selected_old != selected){
    if (selected == 1) {
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
        video_removestring(s->pos.x + (s->width)/2 - 32, s->pos.y+(s->height)/2-4, settings_button_str);
    } else if (selected_old == 1){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_BLACK);
        video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
        video_string(s->pos.x + (s->width)/2 - 32, s->pos.y+(s->height)/2-4, settings_button_str);
    }
    }
}

void settings_button_init(sprite_t*s, int dt){
    s->width = 100;
    s->height = 30;
    vector2d pos = {(right+left)/2-50,(top+bottom)/2-5};
    s->pos = pos;
    s->current_frame = 0;
    s->data = NULL;
    s->frames = 0;
    s->update_func = settings_button_update;
    sprintf(settings_button_str, "Engine Demo");
    video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
    video_string(s->pos.x + (s->width)/2 - 32, s->pos.y+(s->height)/2-4, settings_button_str);
}

sprite_t settings_button = {0,0,0,0,0,0,settings_button_init,0,0};

char credit_button_str[10];
void credit_button_update(sprite_t* s, int dt){
    if (selected_old != selected){
    if (selected == 2){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
        video_removestring(s->pos.x + (s->width)/2 - 19, s->pos.y+(s->height)/2-4, credit_button_str);
    } else if (selected_old == 2){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_BLACK);
        video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
        video_string(s->pos.x + (s->width)/2 - 19, s->pos.y+(s->height)/2-4, credit_button_str);
    }
    }
}

void credit_button_init(sprite_t*s, int dt){
    s->width = 100;
    s->height = 30;
    vector2d pos = {(right+left)/2-50,(top+bottom)/2+30};
    s->pos = pos;
    s->current_frame = 0;
    s->data = NULL;
    s->frames = 0;
    s->update_func = credit_button_update;
    sprintf(credit_button_str, "Credits");
    video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
    video_string(s->pos.x + (s->width)/2 - 19, s->pos.y+(s->height)/2-4, credit_button_str);
}

sprite_t credit_button = {0,0,0,0,0,0,credit_button_init,0,0};

// ============================= menu scene =============================
sprite_t* menu_scene_sprites[3];

char key_string[5];
char key_old = 0;
void scene_menu_update(scene_t* s, int dt){
    int i;
    
    // update the current selected value and play sound effect when keypress detected
    if (getbuttondown(KEY_DOWN)){
        if (!(key_old & 1)) {
            DmaChnEnable(DMAhit);
            selected ++;
            if (selected > 2) selected = 0;
        }
        key_old |= 1;
    } else {
        key_old &= ~(1<<0);
    }
    
    if (getbuttondown(KEY_UP)){
        if (!(key_old & (1<<1))) {
            DmaChnEnable(DMAhit);
            selected --;
            if (selected < 0) selected = 2;
        }
        key_old |= (1 << 1);
    } else {
        key_old &= ~(1 << 1);
    }
    
    // update its children sprites first
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->update_func(s->sprites[i], 0);
    }
    
    selected_old = selected;
    
    sprintf(key_string, "%d", selected);
    video_string(left+10, bottom-10, key_string);
    
    if (getbuttondown(KEY_A)){
        if (!(key_old & (1<<2))) {
            if (selected == 0){
                DmaChnEnable(DMAhit);
                game_manager_get_scene(1)->reset = 1;
                game_manager_load_scene(2);
            } else if (selected == 2){
                DmaChnEnable(DMAhit);
                game_manager_load_scene(5);
            } else {
                DmaChnEnable(DMAhit);
                game_manager_load_scene(6);
            }
        }
        key_old |= (1 << 2);
    } else {
        key_old &= ~(1 << 2);
    }
}

char title_str[10];

void scene_menu_init(scene_t* s, int dt){
    int i;
    
    video_clr(); // clear screen
    
    s->nsprite = 3;
    
    s->sprites = menu_scene_sprites;
    s->sprites[0] = &start_button;
    s->sprites[1] = &settings_button;
    s->sprites[2] = &credit_button;
    
    s->update_func = scene_menu_update;
    
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->init_func(s->sprites[i], 0);
    }
    
    selected = 0;
    selected_old = 0;
    
    // init the scene here
    // Draw the screen boundaries
    video_line(left+30,top+25, right-30,top+25, 1); // top
    video_line(right-30,top+25, right-30,bottom-25, 1); // right
    video_line(right-30,bottom-25, left+30,bottom-25, 1); // bottom
    video_line(left+30,top+25, left+30,bottom-25 ,1); // left
    
    sprintf(title_str, "Rope Jumper");
    video_string((left+right)/2-32, top+35, title_str);
    
    // audio config
    config_bgm(0);
    config_hit(0);
}

scene_t scene_menu = {scene_menu_init, NULL, NULL, 0};